import numpy as np
from epics import caget, caput

from iexcode.instruments.userCalcs import userCalcOut_clear
from iexcode.instruments.IEX_BL_config import *
from iexcode.instruments.userCalcs import userCalcOut_clear

#### Obsolete?

def Bragg_Index_CalcOut(d,eV,th):
    n=8
    userCalcOut_pv = userCalcOut_clear(mda,n)
    
    h=4.135667516e-15
    c=299792458
    f=h*c*1e9*10

    caput(userCalcOut_pv+".DESC","Bragg_Index")
    caput(userCalcOut_pv+".A",d)
    caput(userCalcOut_pv+".B",th)
    caput(userCalcOut_pv+".C",eV)
    caput(userCalcOut_pv+".D",np.pi)
    caput(userCalcOut_pv+".E",f)
    caput(userCalcOut_pv+".CALC$","SIN(B*D/"+str(180)+")*"+str(2)+"*A*C/E")



def KtoE_th_CalcOut():
    n=1
    userCalcOut_pv = userCalcOut_clear(mda,n)

    caput(userCalcOut_pv+".DESC","KtoE_th")
    caput(userCalcOut_pv+".INPA","29idKappa:m8.RBV CP NMS")    #A=kth
    caput(userCalcOut_pv+".INPB","29idKappa:m7.RBV CP NMS")    #B=kap
    caput(userCalcOut_pv+".INPC","29idKappa:m1.RBV CP NMS")    #C=kphi
    caput(userCalcOut_pv+".D",3.141592653589793)
    caput(userCalcOut_pv+".E",180)
    caput(userCalcOut_pv+".F",50)
    caput(userCalcOut_pv+".H",57.045)
    caput(userCalcOut_pv+".CALC$","((A-(G-H))*D/E-ATAN(TAN(B*D/E/2.0)*COS(F*D/E)))*E/D")
    caput(userCalcOut_pv+".DOPT",0)           # Use CAL

def KtoE_chi_CalcOut():
    n=2
    userCalcOut_pv = userCalcOut_clear(mda,n)

    caput(userCalcOut_pv+".DESC","KtoE_chi")
    caput(userCalcOut_pv+".INPA","29idKappa:m8.RBV CP NMS")    #A=kth
    caput(userCalcOut_pv+".INPB","29idKappa:m7.RBV CP NMS")    #B=kap
    caput(userCalcOut_pv+".INPC","29idKappa:m1.RBV CP NMS")    #C=kphi
    caput(userCalcOut_pv+".D",3.141592653589793)
    caput(userCalcOut_pv+".E",180)
    caput(userCalcOut_pv+".F",50)
    caput(userCalcOut_pv+".CALC$","(2*ASIN(SIN(B*D/E/2.0) * SIN(F*D/E)))*E/D")
    caput(userCalcOut_pv+".DOPT",0)           # Use CAL

def KtoE_phi_CalcOut():
    n=3
    userCalcOut_pv = userCalcOut_clear(mda,n)
    
    caput(userCalcOut_pv+".DESC","KtoE_phi")
    caput(userCalcOut_pv+".INPA","29idKappa:m8.RBV CP NMS")    #A=kth
    caput(userCalcOut_pv+".INPB","29idKappa:m7.RBV CP NMS")    #B=kap
    caput(userCalcOut_pv+".INPC","29idKappa:m1.RBV CP NMS")    #C=kphi
    caput(userCalcOut_pv+".D",3.141592653589793)
    caput(userCalcOut_pv+".E",180)
    caput(userCalcOut_pv+".F",50)
    caput(userCalcOut_pv+".CALC$","(C*D/E-ATAN(TAN(B*D/E/2.0)*COS(F*D/E)))*E/D")
    caput(userCalcOut_pv+".DOPT",0)           # Use CAL




def EtoK_kth_CalcOut():
    n=4
    userCalcOut_pv = userCalcOut_clear(mda,n)

    caput(userCalcOut_pv+".DESC","EtoK_kth")
    caput(userCalcOut_pv+".INPA","29idKappa:userCalcOut1.VAL CP NMS")    #A=th
    caput(userCalcOut_pv+".INPB","29idKappa:userCalcOut2.VAL CP NMS")    #B=chi
    caput(userCalcOut_pv+".INPC","29idKappa:userCalcOut3.VAL CP NMS")    #C=phi
    caput(userCalcOut_pv+".D",3.141592653589793)
    caput(userCalcOut_pv+".E",180)
    caput(userCalcOut_pv+".F",50)
    caput(userCalcOut_pv+".CALC$","(A*D/E-ASIN(-TAN(B*D/E/2.0)/TAN(F*D/E)))*E/D")
    caput(userCalcOut_pv+".DOPT",0)           # Use CAL

def EtoK_kap_CalcOut():
    n=5
    userCalcOut_pv = userCalcOut_clear(mda,n)

    caput(userCalcOut_pv+".DESC","EtoK_kap")
    caput(userCalcOut_pv+".INPA","29idKappa:userCalcOut1.VAL CP NMS")    #A=th
    caput(userCalcOut_pv+".INPB","29idKappa:userCalcOut2.VAL CP NMS")    #B=chi
    caput(userCalcOut_pv+".INPC","29idKappa:userCalcOut3.VAL CP NMS")    #C=phi
    caput(userCalcOut_pv+".D",3.141592653589793)
    caput(userCalcOut_pv+".E",180)
    caput(userCalcOut_pv+".F",50)
    caput(userCalcOut_pv+".CALC$","((2*ASIN(SIN(B*D/E/2.0) / SIN(F*D/E))))*E/D")
    caput(userCalcOut_pv+".DOPT",0)           # Use CAL

def EtoK_kphi_CalcOut():
    n=6
    userCalcOut_pv = userCalcOut_clear(mda,n)
    
    caput(userCalcOut_pv+".DESC","EtoK_kphi")
    caput(userCalcOut_pv+".INPA","29idKappa:userCalcOut1.VAL CP NMS")    #A=th
    caput(userCalcOut_pv+".INPB","29idKappa:userCalcOut2.VAL CP NMS")    #B=chi
    caput(userCalcOut_pv+".INPC","29idKappa:userCalcOut3.VAL CP NMS")    #C=phi
    caput(userCalcOut_pv+".D",3.141592653589793)
    caput(userCalcOut_pv+".E",180)
    caput(userCalcOut_pv+".F",50)
    caput(userCalcOut_pv+".CALC$","(C*D/E-ASIN(-TAN(B*D/E/2.0)/TAN(F*D/E)))*E/D")
    caput(userCalcOut_pv+".DOPT",0)           # Use CAL






