
"""
short name for functions used with or without x-rays

"""

import numpy as np
from time import sleep

from epics import PV

import iexcode.instruments.cfg as iex

    




##############################################################################################################
##############################               Beeper          ##############################
##############################################################################################################


def endstation_cams_enable():
    """
    should live in cameras
    """
    endstation=iex.BLendstation
    
    cam_dict={'ARPES':[0,1,2],'Kappa':[3,4,6]}  # index of cam_list 
    pvcam1=PV("29id_ps1:cam1:Acquire")
    pvcam2=PV("29id_ps2:cam1:Acquire")
    pvcam3=PV("29id_ps3:cam1:Acquire")
    pvcam4=PV("29id_ps4:cam1:Acquire")
    pvcam6=PV("29id_ps6:cam1:Acquire")
    pvcam7=PV("29id_ps7:cam1:Acquire")
    cam_list=[pvcam1,pvcam2,pvcam3,pvcam4,pvcam6,pvcam7]
    sleep(0.1)
    for pvcam in cam_list:                  # turn OFF all cam
        try:
            if pvcam.connected:  pvcam.put(0)
        except:
            pass
    for i in cam_dict[endstation]:                 # turn ON relevant cam
        try:
            if cam_list[i].connected: cam_list[i].put(1)
            else: print(cam_list[i].pvname+' not connected')
        except:
            pass

