from re import M
from epics import caput, caget
from iexcode.instruments.utilities import print_warning_message
from iexcode.instruments.m3r import m3r_branch

def hxp_ioc(mirror_name):
    """
    returns the ioc for a given 
    mirror_name: 'm3a' / 'm4a' / 'm4r'
    """
    hxp_namelist={
        'm4r':'hxp2',
        'm3a':'hxp1',
        'm4a':'hxp3',
    }
    if mirror_name not in hxp_namelist:
        print("not a valid mirror name ("+list(hxp_namelist.keys())+")")
    else:
        ioc = '29idHXP:'+hxp_namelist[mirror_name]+":"
        return ioc


def HXP_synch(mirror_name):
    """
    synchs the rbv and sp for all axes

    mirror_name: 'm3a' / 'm4a' / 'm4r'

    Previously: Sync_m4r
    """
    pv = hxp_ioc(mirror_name)
    try:
        for m in range(1,7):
            caput(pv+'m'+str(m)+'.SYNC',1) 
    except:
        print_warning_message("Check if ioc is running")
                
            
def hxp_print(mirror_name):
    """

    Previously: Get_HXP
    """
    pv = hxp_ioc(mirror_name)
 
    Tx=caget(pv+"m1.RBV")
    Ty=caget(pv+"m2.RBV")
    Tz=caget(pv+"m3.RBV")
    Rx=caget(pv+"m4.RBV")
    Ry=caget(pv+"m5.RBV")
    Rz=caget(pv+"m6.RBV")
    print("\n"+mirror_name+" @ "+"%.3f" % Tx, "/","%.3f" % Ty, "/","%.3f" % Tz, "/","%.3f" % Rx, "/","%.3f" % Ry, "/","%.3f" % Rz)

def hxp_get():
    """

    Previously: Get_HXP
    """
    branch = m3r_branch()
    if branch == 'c':
        hxp_print('m3a')
        hxp_print('m4a')
    else:
         hxp_print('m4r')