##############################################################################################################
##############################                 setting folder          from ARPES         ##############################
##############################################################################################################
def folders_ARPES(user_name,**kwargs):
    """
    Create and sets (if create_only=False) all the folders the current run and ARPES user 
    Sets the FileName for logging to be "UserName/YYYYMMDD_log.txt using logname_Set()"
    
    **kwargs:
        set_folders = True (default); set the mda and EA scanRecords
                    = False; only makes the folders (was create_only)
        run: run cycle e.g. 2022_1 (default => check_run() )
        ftp = True / False (default); print what needs to be added to the ftps crontab and create additional ftp folders
        mda_ioc: will overwrite the default ioc for mda scans
        debug
           
    """
    kwargs.setdefault('set_folders',True)
    kwargs.setdefault('run',check_run())
    kwargs.setdefault('ftp',False)
    kwargs.setdefault('debug',False)

    run = kwargs['run']

    if kwargs['debug']:
        print("run,folder,user_name,ioc,ftp: ",run,BL.folder,user_name,BL.ioc,kwargs['ftp'])

    # Create User Folder:
    make_user_folders(run,BL.folder,user_name,BL.endstation,ftp=kwargs['ftp'])
    sleep(5)

    if kwargs["set_folders"]:
        # Set up MDA folder:
        folder_mda(run,BL.folder,user_name,BL.prefix,BL.ioc)
        logfile_name_set(BL.endstation)
        logfile_header(BL.endstation,BL.ioc,ARPES_log_header())

        
        #Set up Scienta folders:
        try:
            userPath = "/net/s29data/export/data_29id"+BL.folder+"/"+run+"/"+user_name+"/"
            folders_EA(userPath,filePrefix="EA")
        except:
            print_warning_message("EA ioc is not running, cannot set folder")